'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _Project = require('../Project');

var _Project2 = _interopRequireDefault(_Project);

var _Workspace = require('../Workspace');

var _Workspace2 = _interopRequireDefault(_Workspace);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(versions) {
    var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var cwd, project, workspaces, updatedPackages, _iterator, _isArray, _i, _ref2, workspace, pkg, promises, _iterator2, _isArray2, _i2, _ref3, depName, depTypes, _iterator3, _isArray3, _i3, _ref4, depType;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            cwd = opts.cwd || process.cwd();
            _context.next = 3;
            return _Project2.default.init(cwd);

          case 3:
            project = _context.sent;
            _context.next = 6;
            return project.getWorkspaces();

          case 6:
            workspaces = _context.sent;
            updatedPackages = new _set2.default();
            _iterator = workspaces, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : (0, _getIterator3.default)(_iterator);

          case 9:
            if (!_isArray) {
              _context.next = 15;
              break;
            }

            if (!(_i >= _iterator.length)) {
              _context.next = 12;
              break;
            }

            return _context.abrupt('break', 58);

          case 12:
            _ref2 = _iterator[_i++];
            _context.next = 19;
            break;

          case 15:
            _i = _iterator.next();

            if (!_i.done) {
              _context.next = 18;
              break;
            }

            return _context.abrupt('break', 58);

          case 18:
            _ref2 = _i.value;

          case 19:
            workspace = _ref2;
            pkg = workspace.pkg;
            promises = [];
            _iterator2 = (0, _keys2.default)(versions), _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : (0, _getIterator3.default)(_iterator2);

          case 23:
            if (!_isArray2) {
              _context.next = 29;
              break;
            }

            if (!(_i2 >= _iterator2.length)) {
              _context.next = 26;
              break;
            }

            return _context.abrupt('break', 56);

          case 26:
            _ref3 = _iterator2[_i2++];
            _context.next = 33;
            break;

          case 29:
            _i2 = _iterator2.next();

            if (!_i2.done) {
              _context.next = 32;
              break;
            }

            return _context.abrupt('break', 56);

          case 32:
            _ref3 = _i2.value;

          case 33:
            depName = _ref3;
            depTypes = pkg.getDependencyTypes(depName);

            if (!(depTypes.length === 0)) {
              _context.next = 37;
              break;
            }

            return _context.abrupt('continue', 54);

          case 37:
            _iterator3 = depTypes, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : (0, _getIterator3.default)(_iterator3);

          case 38:
            if (!_isArray3) {
              _context.next = 44;
              break;
            }

            if (!(_i3 >= _iterator3.length)) {
              _context.next = 41;
              break;
            }

            return _context.abrupt('break', 53);

          case 41:
            _ref4 = _iterator3[_i3++];
            _context.next = 48;
            break;

          case 44:
            _i3 = _iterator3.next();

            if (!_i3.done) {
              _context.next = 47;
              break;
            }

            return _context.abrupt('break', 53);

          case 47:
            _ref4 = _i3.value;

          case 48:
            depType = _ref4;
            _context.next = 51;
            return pkg.setDependencyVersionRange(depName, depType, '^' + versions[depName]);

          case 51:
            _context.next = 38;
            break;

          case 53:
            updatedPackages.add(pkg.filePath);

          case 54:
            _context.next = 23;
            break;

          case 56:
            _context.next = 9;
            break;

          case 58:
            return _context.abrupt('return', (0, _from2.default)(updatedPackages));

          case 59:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function updatePackageVersions(_x2) {
    return _ref.apply(this, arguments);
  }

  return updatePackageVersions;
}();